﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameServer : MonoBehaviour
{
    TelnetHost telnetHost;

    int serverUDPPort, serverWebGLPort, serverTelnetPort;

    private void Awake()
    {
        telnetHost = GetComponent<TelnetHost>();

    }
    public void SetPorts(int udpPort, int webglPort, int telnetPort)
    {
        serverUDPPort = udpPort;
        serverWebGLPort = webglPort;
        serverTelnetPort = telnetPort;
    }

    // Use this for initialization
    void Start ()
    {
        RTNetworkServer.Get().OnPacketStringEvent += OnPacketStringEvent;
    }

    void OnPacketStringEvent(string text, RTClientConnection client)
    {
        if (text == "/stats")
        {
            RTNetworkManager.Get().SendString(client, "`$"+RTNetworkManager.Get().GetStats()+"\r\n"+RTNetworkServer.Get().GetStats()+"``");
            return;
        }

        RTNetworkServer.Get().SendStringToAll("Client "+client.connectionID+" : " +text);
    }

    public void OnShowStats()
    {
        if (!RTNetworkServer.Get().DidSetup())
        {
            RTConsole.Log("Host not initted yet");
            return;
        }

        RTConsole.Log("`$" + RTNetworkManager.Get().GetStats()+"\r\n"+ RTNetworkServer.Get().GetStats()+"``");
    }

    public void InitServer()
    {
        telnetHost.Setup(serverTelnetPort);
        RTNetworkServer.Get().Setup(serverUDPPort, serverWebGLPort);
    }

    public void InitServerLocal()
    {
        RTConsole.Log("Switching to localhost");
        GameLogic.Get().SetServerURL("localhost");
        InitServer();
    }

    // Update is called once per frame
    void Update ()
    {
		
	}
}
